execute unless entity @e[type=blaze,tag=kazzxv.boss] run scoreboard players set xv_pb_fireball kazzxv.raycast 0

#Fireball Attack Setup
execute if entity @e[type=blaze,tag=kazzxv.boss,distance=..6] unless entity @s[tag=kazzxv.pb_blast] run tag @s add kazzxv.pb_fireball
execute if entity @s[tag=kazzxv.pb_fireball] unless entity @e[type=blaze,tag=kazzxv.boss,distance=..40] run kill @s

#Attack
execute as @s[tag=kazzxv.pb_fireball] run scoreboard players set xv_primordial kazzxv.raycast 0
execute as @s[tag=kazzxv.pb_fireball] run scoreboard players set xv_pb_fireball kazzxv.raycast 0
execute as @s[tag=kazzxv.pb_fireball] if predicate kazzmon.extravanilla:5_percent run scoreboard players set xv_pb_fireball kazzxv.raycast 1
execute as @s[tag=kazzxv.pb_fireball] if predicate kazzmon.extravanilla:5_percent run scoreboard players set xv_pb_fireball kazzxv.raycast 2
execute as @s[tag=kazzxv.pb_fireball] if score xv_pb_fireball kazzxv.raycast matches 1 rotated ~180 ~ run function kazzmon.extravanilla:mobs/custom_bosses/primordial_blaze_bossfight/attack/aoe_lightning
execute as @s[tag=kazzxv.pb_fireball] if score xv_pb_fireball kazzxv.raycast matches 2 rotated ~180 ~ run function kazzmon.extravanilla:mobs/custom_bosses/primordial_blaze_bossfight/attack/fire_blast

#Sound Effects
  #Lightning Strike
execute as @s[tag=kazzxv.pb_fireball] if score xv_pb_fireball kazzxv.raycast matches 1 run playsound minecraft:block.respawn_anchor.deplete ambient @a ~ ~ ~ 3 1.3
execute as @s[tag=kazzxv.pb_fireball] if score xv_pb_fireball kazzxv.raycast matches 1 run playsound minecraft:block.respawn_anchor.deplete ambient @a ~ ~ ~ 3 1
execute as @s[tag=kazzxv.pb_fireball] if score xv_pb_fireball kazzxv.raycast matches 1 run playsound minecraft:block.respawn_anchor.deplete ambient @a ~ ~ ~ 3 0.8
execute as @s[tag=kazzxv.pb_fireball] if score xv_pb_fireball kazzxv.raycast matches 1 run playsound minecraft:entity.blaze.shoot ambient @a ~ ~ ~ 3 0.8
execute as @s[tag=kazzxv.pb_fireball] if score xv_pb_fireball kazzxv.raycast matches 1 run playsound minecraft:entity.blaze.shoot ambient @a ~ ~ ~ 3 0.5
execute as @s[tag=kazzxv.pb_fireball] if score xv_pb_fireball kazzxv.raycast matches 1 run playsound minecraft:entity.blaze.burn ambient @a ~ ~ ~ 3 1
  #Fire Blast
execute as @s[tag=kazzxv.pb_fireball] if score xv_pb_fireball kazzxv.raycast matches 2 run playsound minecraft:entity.blaze.shoot ambient @a ~ ~ ~ 3 1.3
execute as @s[tag=kazzxv.pb_fireball] if score xv_pb_fireball kazzxv.raycast matches 2 run playsound minecraft:entity.blaze.shoot ambient @a ~ ~ ~ 3 1
execute as @s[tag=kazzxv.pb_fireball] if score xv_pb_fireball kazzxv.raycast matches 2 run playsound minecraft:entity.blaze.shoot ambient @a ~ ~ ~ 3 0.8
execute as @s[tag=kazzxv.pb_fireball] if score xv_pb_fireball kazzxv.raycast matches 2 run playsound minecraft:entity.blaze.shoot ambient @a ~ ~ ~ 3 0.5
execute as @s[tag=kazzxv.pb_fireball] if score xv_pb_fireball kazzxv.raycast matches 2 run playsound minecraft:entity.blaze.burn ambient @a ~ ~ ~ 3 1

#Removes Fireball once Attack is over
execute as @s[tag=kazzxv.pb_fireball] if score xv_pb_fireball kazzxv.raycast matches 1.. run kill @s

#Fire Blast Fireball Damage
execute at @s[tag=kazzxv.pb_blast] as @a[distance=..3,tag=!kazzxv.boss_hit] run function kazzmon.extravanilla:mobs/custom_bosses/primordial_blaze_bossfight/attack/hit
execute as @s[tag=kazzxv.pb_blast] at @s if predicate kazzmon.extravanilla:50_percent run particle minecraft:lava ~ ~ ~ 0 0 0 0 1 normal