#Set Duration
execute if entity @s[tag=!kazzxv.aw_atk_setup] run scoreboard players set #xv_abyss_atk_duration kazzxv.aw_atk 310
execute if entity @s[tag=!kazzxv.aw_atk_setup] run scoreboard players set #xv_abyss_atk_cd kazzxv.aw_atk 0

#Tags Suspects for Attack
execute if entity @s[tag=!kazzxv.aw_atk_setup] as @e[type=#kazzmon.extravanilla:abyss_watcher_targets_no_player, distance=..128] run function kazzmon.extravanilla:mobs/custom_bosses/abyss_watcher/main/attacks/setup_target
execute if entity @s[tag=!kazzxv.aw_atk_setup] as @a[distance=..128, gamemode=!creative, gamemode=!spectator] run function kazzmon.extravanilla:mobs/custom_bosses/abyss_watcher/main/attacks/setup_target

#Tags for Setup
tag @s[tag=!kazzxv.aw_atk_setup] add kazzxv.aw_atk_setup

#Attack
  #Levitate
execute if score #xv_abyss_atk_duration kazzxv.aw_atk matches 310.. run data merge entity @s {Motion:[0.0,1.0,0.0]}
execute if score #xv_abyss_atk_duration kazzxv.aw_atk matches 310.. run effect give @s levitation 2 2 true
execute if score #xv_abyss_atk_duration kazzxv.aw_atk matches 1..270 run effect give @s levitation 2 0 true

  #Abyssal Beam
execute if score #xv_abyss_atk_duration kazzxv.aw_atk matches 270 run playsound minecraft:entity.warden.roar ambient @a ~ ~ ~ 5 1
execute if score #xv_abyss_atk_duration kazzxv.aw_atk matches 270 run playsound minecraft:entity.warden.sonic_charge ambient @a ~ ~ ~ 5 1
execute if score #xv_abyss_atk_duration kazzxv.aw_atk matches 270 run playsound minecraft:entity.warden.sonic_charge ambient @a ~ ~ ~ 5 0.7
execute if score #xv_abyss_atk_duration kazzxv.aw_atk matches 270 run playsound minecraft:entity.warden.sonic_charge ambient @a ~ ~ ~ 5 0.5
execute if score #xv_abyss_atk_duration kazzxv.aw_atk matches 270 run playsound minecraft:entity.warden.death ambient @a ~ ~ ~ 5 1
execute if score #xv_abyss_atk_duration kazzxv.aw_atk matches 270 run playsound minecraft:entity.warden.death ambient @a ~ ~ ~ 5 0.7
execute if score #xv_abyss_atk_duration kazzxv.aw_atk matches 270 run playsound minecraft:block.sculk_shrieker.shriek ambient @a ~ ~ ~ 5 1.3
execute if score #xv_abyss_atk_duration kazzxv.aw_atk matches 270 run playsound minecraft:block.sculk_shrieker.shriek ambient @a ~ ~ ~ 5 1.2
execute if score #xv_abyss_atk_duration kazzxv.aw_atk matches 1..210 if score #xv_abyss_atk_cd kazzxv.aw_atk matches 0 anchored eyes facing entity @e[tag=kazzxv.aw_target,sort=nearest,limit=1] feet positioned ^ ^ ^ if entity @e[tag=kazzxv.aw_target] run function kazzmon.extravanilla:mobs/custom_bosses/abyss_watcher/main/attacks/abyssal_beam/start
execute if score #xv_abyss_atk_duration kazzxv.aw_atk matches 1..210 if score #xv_abyss_atk_cd kazzxv.aw_atk matches 0 anchored eyes positioned ^ ^ ^ rotated ~ ~ unless entity @e[tag=kazzxv.aw_target] run function kazzmon.extravanilla:mobs/custom_bosses/abyss_watcher/main/attacks/abyssal_beam/start

#Tick Down Duration and Cooldown
execute if score #xv_abyss_atk_duration kazzxv.aw_atk matches 1.. run scoreboard players remove #xv_abyss_atk_duration kazzxv.aw_atk 1
execute if score #xv_abyss_atk_cd kazzxv.aw_atk matches 1.. run scoreboard players remove #xv_abyss_atk_cd kazzxv.aw_atk 1

#Finished Attack
  #Set Cooldown
execute if score #xv_abyss_atk_duration kazzxv.aw_atk matches 0 run scoreboard players set @s kazzxv.aw_cd 350

  #Slow Fall
execute if score #xv_abyss_atk_duration kazzxv.aw_atk matches 0 run effect give @s slow_falling 12 0 true

  #Removes Tags
execute if score #xv_abyss_atk_duration kazzxv.aw_atk matches 0 run tag @s remove kazzxv.aw_attacking
execute if score #xv_abyss_atk_duration kazzxv.aw_atk matches 0 run tag @s remove kazzxv.aw_atk_setup
execute if score #xv_abyss_atk_duration kazzxv.aw_atk matches 0 run tag @e remove kazzxv.aw_target

#Run when in Stagger Rush
execute if entity @s[tag=kazzxv.aw_stagger_rush] if score #xv_abyss_atk_duration kazzxv.aw_atk matches 0 run tag @s add kazzxv.aw_attacking
execute if entity @s[tag=kazzxv.aw_stagger_rush] if score #xv_abyss_atk_duration kazzxv.aw_atk matches 0 run scoreboard players set @s kazzxv.aw_cd 30
execute if entity @s[tag=kazzxv.aw_stagger_rush] if score #xv_abyss_atk_duration kazzxv.aw_atk matches 0 run scoreboard players add #xv_abyss_stagger_phase kazzxv.aw_stgr 1